package whatsapp

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/whatsapp"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /whatsapp/deregisterPhoneNumber whatsapp DeregisterPhoneNumber
//
// 取消注册WhatsApp号码
//
// 取消注册WhatsApp号码
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: deregisterReq
//
// Responses:
//  200: BaseMsgResp

func DeregisterPhoneNumberHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.DeregisterReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := whatsapp.NewDeregisterPhoneNumberLogic(r.Context(), svcCtx)
		resp, err := l.DeregisterPhoneNumber(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
